package de.hottis.MeasurementCollector;

import javax.jms.Connection;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Session;

import org.apache.activemq.ActiveMQConnectionFactory;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public abstract class AJmsQueue {
	final protected Logger logger = LogManager.getRootLogger();

	protected Connection connection;
	protected Session session;
	protected Destination destination;

	public AJmsQueue() {

	}


	public void init() throws MeasurementCollectorException {
		try {
			ActiveMQConnectionFactory connectionFactory = new ActiveMQConnectionFactory("tcp://localhost:61616");
			logger.debug("connectionFactory: " + connectionFactory);
			connection = connectionFactory.createConnection();
			connection.start();
			logger.debug("connection: " + connection);
			session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
			logger.debug("session: " + session);
			destination = session.createQueue("TEST.FOO");
			logger.debug("destination: " + destination);
		} catch (JMSException e) {
			logger.error("JMSException in AJmsQueue.init", e); 
			throw new MeasurementCollectorException("JMSException in AJmsQueue.init", e);
		}
	}


}
