package de.hottis.MeasurementCollector;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Properties;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public abstract class AMessageParser {
	final protected Logger logger = LogManager.getRootLogger();

	private String topic;
	//private DataObjectQueue queue;
	private JmsQueueProducer<ADataObject> jmsQueue = new JmsQueueProducer<ADataObject>();
	protected Properties config;

	public AMessageParser(String topic, Properties config, DataObjectQueue queue) {
		this.topic = topic;
		this.config = config;
		//this.queue = queue;
	}

	public void init() throws MeasurementCollectorException {
		jmsQueue.init();
	}


	public String getTopic() {
		return this.topic;
	}

	public void enqueue(List<ADataObject> itemList) throws MeasurementCollectorException {
		for (ADataObject ado : itemList) {
			jmsQueue.enqueue(ado);
			logger.debug("message enqueued");
		}

		//queue.add(itemList);
		//logger.debug("Queue size: " + queue.size());
	}

	abstract public void execute(LocalDateTime timestamp, String msgPayload);
}
