package de.hottis.MeasurementCollector;

import java.io.Serializable;

import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;

public class JmsQueueProducer<T extends Serializable> extends AJmsQueue {
	private MessageProducer producer;

	public JmsQueueProducer() {
		super();
	}

	public void init() throws MeasurementCollectorException {
		super.init();

		try {
			producer = session.createProducer(destination);
			producer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
			logger.debug("producer: " + producer);
		} catch (JMSException e) {
			logger.error("JMSException in AJmsQueue.init", e); 
			throw new MeasurementCollectorException("JMSException in JmsQueueProducer.init", e);
		}
	}

	public void enqueue(T item) throws MeasurementCollectorException {
		try {
			ObjectMessage message = session.createObjectMessage();
			message.setObject(item);
			producer.send(message);
			logger.debug("message enqueued");
		} catch (JMSException e) {
			logger.error("JMSException in JmsQueueProducer.enqueue", e);
			logger.error("Calling init");
			init();
			throw new MeasurementCollectorException("JMSException in JmsQueueProducer.enqueue", e);
		}
	}

}
